Tonyu.klass.define({
  fullName: 'user.Cells',
  shortName: 'Cells',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.Actor,
  includes: [],
  methods: function (__superClass) {
    return {
      main :function _trc_Cells_main() {
        "use strict";
        var _this=this;
        
        _this.waitEvent("start");
        while (true) {
          _this.calc();
          _this.update();
          
        }
      },
      fiber$main :function _trc_Cells_f_main(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        
        _thread.enter(function _trc_Cells_ent_main(_thread) {
          if (_thread.lastEx) __pc=_thread.catchPC;
          for(var __cnt=100 ; __cnt--;) {
            switch (__pc) {
            case 0:
              _this.fiber$waitEvent(_thread, "start");
              __pc=1;return;
            case 1:
              
            case 2:
              _this.calc();
              _this.fiber$update(_thread);
              __pc=3;return;
            case 3:
              
              __pc=2;break;
            case 4     :
              
              _thread.exit(_this);return;
            }
          }
        });
      },
      onAppear :function _trc_Cells_onAppear() {
        "use strict";
        var _this=this;
        var i;
        
        _this.cur=new Tonyu.classes.user.LMatrix({row: Tonyu.globals.$r,col: Tonyu.globals.$c});
        _this.next=new Tonyu.classes.user.LMatrix({row: Tonyu.globals.$r,col: Tonyu.globals.$c});
        _this.coltbl=[];
        i = 0;
        for (; i<2 ; i++) {
          {
            _this.coltbl.push(new Tonyu.classes.kernel.Color({h: i*180,s: 0.5,l: 0.3}));
            _this.coltbl.push(new Tonyu.classes.kernel.Color({h: i*180,s: 0.5,l: 0.5}));
          }
        }
      },
      fiber$onAppear :function _trc_Cells_f_onAppear(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var i;
        
        _this.cur=new Tonyu.classes.user.LMatrix({row: Tonyu.globals.$r,col: Tonyu.globals.$c});
        _this.next=new Tonyu.classes.user.LMatrix({row: Tonyu.globals.$r,col: Tonyu.globals.$c});
        _this.coltbl=[];
        i = 0;
        for (; i<2 ; i++) {
          {
            _this.coltbl.push(new Tonyu.classes.kernel.Color({h: i*180,s: 0.5,l: 0.3}));
            _this.coltbl.push(new Tonyu.classes.kernel.Color({h: i*180,s: 0.5,l: 0.5}));
          }
        }
        
        _thread.retVal=_this;return;
      },
      draw :function _trc_Cells_draw(c) {
        "use strict";
        var _this=this;
        var i;
        var j;
        var n;
        var tmp;
        
        i = Tonyu.globals.$frameCount%Tonyu.globals.$r;
        
        i=0;for (; i<Tonyu.globals.$r ; i++) {
          {
            j=0;for (; j<Tonyu.globals.$c ; j++) {
              {
                n=_this.cur.get(j,i);
                c.fillStyle=_this.coltbl[n];
                c.fillRect(j*Tonyu.globals.$p,i*Tonyu.globals.$p,Tonyu.globals.$p-1,Tonyu.globals.$p-1);
              }
            }
          }
        }
      },
      __getter__sum :function _trc_Cells___getter__sum() {
        "use strict";
        var _this=this;
        var r;
        
        r = 0;
        
        _this.i=0;for (; _this.i<Tonyu.globals.$r ; _this.i++) {
          {
            _this.j=0;for (; _this.j<Tonyu.globals.$c ; _this.j++) {
              {
                r+=_this.cur.get(_this.j,_this.i)*(_this.i*0.7+_this.j*0.3);
              }
            }
          }
        }
        return r;
      },
      calc :function _trc_Cells_calc() {
        "use strict";
        var _this=this;
        var i;
        var j;
        var n;
        var c;
        var cc;
        var tmp;
        var di;
        var dj;
        var col;
        var same;
        
        c = 0;
        
        _this.colStat=[0,0,0,0];
        i=0;for (; i<Tonyu.globals.$r ; i++) {
          {
            j=0;for (; j<Tonyu.globals.$c ; j++) {
              {
                c=0;
                same=true;
                col=null;
                di=- 1;for (; di<=1 ; di++) {
                  {
                    dj=- 1;for (; dj<=1 ; dj++) {
                      {
                        if (di==0&&dj==0) {
                          continue;
                          
                        }
                        cc=(_this.cur.get(j+dj,i+di)||0);
                        if (cc%2==1) {
                          if (col!=null&&col!=_this.floor(cc/2)) {
                            same=false;
                            
                          } else {
                            col=_this.floor(cc/2);
                            
                          }
                          c++;
                          
                        }
                      }
                    }
                  }
                }
                switch (c) {
                case 2:
                  n=_this.cur.get(j,i)%2;
                  break;
                  
                case 3:
                  n=1;
                  break;
                  
                default:
                  n=0;
                }
                if (same&&col!=null) {
                  n+=col*2;
                  
                } else {
                  n+=_this.floor(_this.cur.get(j,i)/2)*2;
                  
                }
                _this.colStat[n]++;
                _this.next.set(j,i,n);
              }
            }
          }
        }
        tmp=_this.cur;
        _this.cur=_this.next;
        _this.next=tmp;
      },
      __dummy: false
    };
  },
  decls: {"methods":{"main":{"nowait":false},"onAppear":{"nowait":false},"draw":{"nowait":true},"__getter__sum":{"nowait":true},"calc":{"nowait":true}},"fields":{"cur":{},"next":{},"coltbl":{},"i":{},"j":{},"colStat":{}}}
});
Tonyu.klass.define({
  fullName: 'user.CLife',
  shortName: 'CLife',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.TObject,
  includes: [],
  methods: function (__superClass) {
    return {
      main :function _trc_CLife_main() {
        "use strict";
        var _this=this;
        
        _this.mat=new Tonyu.classes.kernel.Matrix;
        _this.name=_this.name||"name";
      },
      fiber$main :function _trc_CLife_f_main(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        _this.mat=new Tonyu.classes.kernel.Matrix;
        _this.name=_this.name||"name";
        
        _thread.retVal=_this;return;
      },
      load :function _trc_CLife_load(n) {
        "use strict";
        var _this=this;
        var ofs;
        var i;
        var m;
        var x;
        var y;
        var p;
        var _it_536;
        
        ofs = 0;
        
        i = 0;
        for (; i<_this.name.length ; i++) {
          {
            m = n.getPat(_this.name[i]);
            
            console.log(_this.name[i]);
            _it_536=Tonyu.iterator(m,3);
            while(_it_536.next()) {
              x=_it_536[0];
              y=_it_536[1];
              p=_it_536[2];
              
              _this.mat.set(x+ofs,y,p);
              
            }
            ofs+=16;
          }
        }
      },
      fiber$load :function _trc_CLife_f_load(_thread,n) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var ofs;
        var i;
        var m;
        var x;
        var y;
        var p;
        var _it_536;
        
        ofs = 0;
        
        i = 0;
        for (; i<_this.name.length ; i++) {
          {
            m = n.getPat(_this.name[i]);
            
            console.log(_this.name[i]);
            _it_536=Tonyu.iterator(m,3);
            while(_it_536.next()) {
              x=_it_536[0];
              y=_it_536[1];
              p=_it_536[2];
              
              _this.mat.set(x+ofs,y,p);
              
            }
            ofs+=16;
          }
        }
        
        _thread.retVal=_this;return;
      },
      save :function _trc_CLife_save(file) {
        "use strict";
        var _this=this;
        var bin;
        var i;
        var c;
        var j;
        var r;
        var m;
        var b;
        
        bin = [_this.name.length];
        
        i = 0;
        for (; i<_this.name.length ; i++) {
          {
            c = _this.name.charCodeAt(i);
            
            bin.push(c&255);
            bin.push(c>>8);
          }
        }
        
        j=0;for (; j<2 ; j++) {
          {
            r=0;for (; r<16 ; r++) {
              {
                b = 0;
                
                m=0;for (; m<8 ; m++) {
                  {
                    b=b<<1;
                    b+=_this.mat.get(j*8+m,r);
                  }
                }
                bin.push(b);
              }
            }
          }
        }
        file.setBytes(new Uint8Array(bin));
      },
      fiber$save :function _trc_CLife_f_save(_thread,file) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var bin;
        var i;
        var c;
        var j;
        var r;
        var m;
        var b;
        
        bin = [_this.name.length];
        
        i = 0;
        for (; i<_this.name.length ; i++) {
          {
            c = _this.name.charCodeAt(i);
            
            bin.push(c&255);
            bin.push(c>>8);
          }
        }
        
        j=0;for (; j<2 ; j++) {
          {
            r=0;for (; r<16 ; r++) {
              {
                b = 0;
                
                m=0;for (; m<8 ; m++) {
                  {
                    b=b<<1;
                    b+=_this.mat.get(j*8+m,r);
                  }
                }
                bin.push(b);
              }
            }
          }
        }
        file.setBytes(new Uint8Array(bin));
        
        _thread.retVal=_this;return;
      },
      createThumb :function _trc_CLife_createThumb() {
        "use strict";
        var _this=this;
        var p;
        var i;
        var j;
        
        p = new Tonyu.classes.kernel.Panel({width: 32,height: 32});
        
        p.fillStyle="#666";
        p.fillRect(0,0,32,32);
        p.fillStyle="white";
        i = 0;
        for (; i<16 ; i++) {
          {
            j = 0;
            for (; j<16 ; j++) {
              {
                if (_this.mat.get(j,i)) {
                  p.fillRect(j*2,i*2,2,2);
                }
              }
            }
          }
        }
        return p;
      },
      fiber$createThumb :function _trc_CLife_f_createThumb(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var p;
        var i;
        var j;
        
        p = new Tonyu.classes.kernel.Panel({width: 32,height: 32});
        
        p.fillStyle="#666";
        p.fillRect(0,0,32,32);
        p.fillStyle="white";
        i = 0;
        for (; i<16 ; i++) {
          {
            j = 0;
            for (; j<16 ; j++) {
              {
                if (_this.mat.get(j,i)) {
                  p.fillRect(j*2,i*2,2,2);
                }
              }
            }
          }
        }
        _thread.retVal=p;return;
        
        
        _thread.retVal=_this;return;
      },
      toURL :function _trc_CLife_toURL() {
        "use strict";
        var _this=this;
        
      },
      fiber$toURL :function _trc_CLife_f_toURL(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        
        _thread.retVal=_this;return;
      },
      fromURL :function _trc_CLife_fromURL() {
        "use strict";
        var _this=this;
        
      },
      fiber$fromURL :function _trc_CLife_f_fromURL(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        
        _thread.retVal=_this;return;
      },
      __dummy: false
    };
  },
  decls: {"methods":{"main":{"nowait":false},"load":{"nowait":false},"save":{"nowait":false},"createThumb":{"nowait":false},"toURL":{"nowait":false},"fromURL":{"nowait":false}},"fields":{"mat":{},"name":{}}}
});
Tonyu.klass.define({
  fullName: 'user.Files',
  shortName: 'Files',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.Actor,
  includes: [],
  methods: function (__superClass) {
    return {
      main :function _trc_Files_main() {
        "use strict";
        var _this=this;
        
        Tonyu.globals.$r=60;
        Tonyu.globals.$c=40;
        Tonyu.globals.$p=6;
        Tonyu.globals.$Screen.resize(Tonyu.globals.$c*Tonyu.globals.$p,Tonyu.globals.$r*Tonyu.globals.$p);
        Tonyu.globals.$w=Tonyu.globals.$screenWidth;
        Tonyu.globals.$h=Tonyu.globals.$screenHeight;
        Tonyu.globals.$InputBox.useNative=true;
        Tonyu.globals.$mu=new Tonyu.classes.user.MapURL;
        _this.dir=FS.get(_this.file("chars/").path());
        _this.dir.mkdir();
        _this.i = 0;
        for (; _this.i<6 ; _this.i++) {
          _this.show(_this.i);
        }
        new Tonyu.classes.kernel.Button({top: Tonyu.globals.$h-50,height: 30,text: "Fight!",onClick: (function anonymous_277() {
          
          _this.loadPage(Tonyu.classes.user.Main);
        })});
      },
      fiber$main :function _trc_Files_f_main(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        Tonyu.globals.$r=60;
        Tonyu.globals.$c=40;
        Tonyu.globals.$p=6;
        Tonyu.globals.$Screen.resize(Tonyu.globals.$c*Tonyu.globals.$p,Tonyu.globals.$r*Tonyu.globals.$p);
        Tonyu.globals.$w=Tonyu.globals.$screenWidth;
        Tonyu.globals.$h=Tonyu.globals.$screenHeight;
        Tonyu.globals.$InputBox.useNative=true;
        Tonyu.globals.$mu=new Tonyu.classes.user.MapURL;
        _this.dir=FS.get(_this.file("chars/").path());
        _this.dir.mkdir();
        _this.i = 0;
        for (; _this.i<6 ; _this.i++) {
          _this.show(_this.i);
        }
        
        _thread.enter(function _trc_Files_ent_main(_thread) {
          if (_thread.lastEx) __pc=_thread.catchPC;
          for(var __cnt=100 ; __cnt--;) {
            switch (__pc) {
            case 0:
              new Tonyu.classes.kernel.Button({top: Tonyu.globals.$h-50,height: 30,text: "Fight!",onClick: (function anonymous_277() {
                
                _this.loadPage(Tonyu.classes.user.Main);
              })});
              _thread.exit(_this);return;
            }
          }
        });
      },
      show :function _trc_Files_show(i) {
        "use strict";
        var _this=this;
        var f;
        var c;
        var pp;
        
        f = _this.dir.rel("p"+i);
        
        c = new Tonyu.classes.user.CLife;
        
        if (f.exists()) {
          c.load(f);
          
        }
        pp = c.createThumb();
        
        pp.position.set(50,i*40+50);
        pp.on("touch",(function anonymous_483() {
          
          _this.loadPage(Tonyu.classes.user.Graph,{lFile: f});
        }));
        new Tonyu.classes.kernel.Label({x: 80,y: i*40+50,text: c.name,align: "left"});
        new Tonyu.classes.kernel.Button({left: 180,top: i*40+40,width: 60,height: 24,text: "Share",clickTiming: "release",onClick: (function anonymous_703() {
          var u;
          var nu;
          
          u = f.exists()?f.dataURL().replace(/^data:application\/octet-stream;base64,/,""):"";
          
          nu = Tonyu.globals.$InputBox.prompt("share",u);
          
          if (nu&&nu!==u) {
            f.dataURL("data:application/octet-stream;base64,"+nu);
            _this.loadPage(Tonyu.classes.user.Files);
            
          }
        })});
      },
      __dummy: false
    };
  },
  decls: {"methods":{"main":{"nowait":false},"show":{"nowait":true}},"fields":{"i":{},"dir":{}}}
});
Tonyu.klass.define({
  fullName: 'user.Graph',
  shortName: 'Graph',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.Actor,
  includes: [],
  methods: function (__superClass) {
    return {
      main :function _trc_Graph_main() {
        "use strict";
        var _this=this;
        
        Tonyu.globals.$r=60;
        Tonyu.globals.$c=40;
        Tonyu.globals.$p=6;
        Tonyu.globals.$Screen.resize(Tonyu.globals.$c*Tonyu.globals.$p,Tonyu.globals.$r*Tonyu.globals.$p);
        Tonyu.globals.$w=Tonyu.globals.$screenWidth;
        Tonyu.globals.$h=Tonyu.globals.$screenHeight;
        Tonyu.globals.$Screen.setBGColor("black");
        _this.rc=16;
        _this.size=12;
        _this.cLife=new Tonyu.classes.user.CLife;
        if (_this.lFile&&_this.lFile.exists()) {
          _this.cLife.load(_this.lFile);
          
        }
        _this.mat=_this.cLife.mat;
        new Tonyu.classes.kernel.Label({x: 100,y: 10,text: "name:"});
        _this.nlbl=new Tonyu.classes.kernel.Label({x: 120,y: 50,text: _this.cLife.name});
        new Tonyu.classes.kernel.Button({top: 30,left: Tonyu.globals.$w-100,width: 80,text: "change",height: 24,clickTiming: "release",onClick: (function anonymous_431() {
          var n;
          
          Tonyu.globals.$InputBox.useNative=true;
          n = Tonyu.globals.$InputBox.prompt(_this.cLife.name);
          
          _this.cLife.name=n||_this.cLife.name;
          _this.nlbl.text=_this.cLife.name;
        })});
        new Tonyu.classes.kernel.Button({top: Tonyu.globals.$h-70,height: 30,text: "TEST",onClick: (function anonymous_639() {
          
          _this.loadPage(Tonyu.classes.user.Main,{test: _this.mat},true);
        })});
        new Tonyu.classes.kernel.Button({top: Tonyu.globals.$h-30,height: 30,text: "SAVE",onClick: (function anonymous_737() {
          
          _this.cLife.save(_this.lFile);
          _this.loadPage(Tonyu.classes.user.Files);
        })});
        _this.pa=new Tonyu.classes.kernel.Panel({x: Tonyu.globals.$w/2,y: Tonyu.globals.$h/2,width: _this.rc*_this.size,height: _this.rc*_this.size});
        _this.pa.on("touch",(function anonymous_976(e) {
          var f;
          var val;
          
          f = e.finger;
          
          _this.px=_this.py=null;
          val = _this.putChipByFinger(f);
          
          f.on("move",(function anonymous_1086(e) {
            var f;
            
            f = e.finger;
            
            _this.putChipByFinger(f,val);
          }));
        }));
        _this.padding={w: (Tonyu.globals.$w-_this.rc*_this.size)/2,h: (Tonyu.globals.$h-_this.rc*_this.size)/2};
        _this.i=0;for (; _this.i<_this.rc ; _this.i++) {
          {
            _this.j=0;for (; _this.j<_this.rc ; _this.j++) {
              {
                _this.putChip(_this.i,_this.j,_this.mat.get(_this.j,_this.i)==1);
              }
            }
          }
        }
      },
      fiber$main :function _trc_Graph_f_main(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        Tonyu.globals.$r=60;
        Tonyu.globals.$c=40;
        Tonyu.globals.$p=6;
        Tonyu.globals.$Screen.resize(Tonyu.globals.$c*Tonyu.globals.$p,Tonyu.globals.$r*Tonyu.globals.$p);
        Tonyu.globals.$w=Tonyu.globals.$screenWidth;
        Tonyu.globals.$h=Tonyu.globals.$screenHeight;
        Tonyu.globals.$Screen.setBGColor("black");
        _this.rc=16;
        _this.size=12;
        _this.cLife=new Tonyu.classes.user.CLife;
        if (_this.lFile&&_this.lFile.exists()) {
          _this.cLife.load(_this.lFile);
          
        }
        _this.mat=_this.cLife.mat;
        new Tonyu.classes.kernel.Label({x: 100,y: 10,text: "name:"});
        _this.nlbl=new Tonyu.classes.kernel.Label({x: 120,y: 50,text: _this.cLife.name});
        new Tonyu.classes.kernel.Button({top: 30,left: Tonyu.globals.$w-100,width: 80,text: "change",height: 24,clickTiming: "release",onClick: (function anonymous_431() {
          var n;
          
          Tonyu.globals.$InputBox.useNative=true;
          n = Tonyu.globals.$InputBox.prompt(_this.cLife.name);
          
          _this.cLife.name=n||_this.cLife.name;
          _this.nlbl.text=_this.cLife.name;
        })});
        
        _thread.enter(function _trc_Graph_ent_main(_thread) {
          if (_thread.lastEx) __pc=_thread.catchPC;
          for(var __cnt=100 ; __cnt--;) {
            switch (__pc) {
            case 0:
              new Tonyu.classes.kernel.Button({top: Tonyu.globals.$h-70,height: 30,text: "TEST",onClick: (function anonymous_639() {
                
                _this.loadPage(Tonyu.classes.user.Main,{test: _this.mat},true);
              })});
              new Tonyu.classes.kernel.Button({top: Tonyu.globals.$h-30,height: 30,text: "SAVE",onClick: (function anonymous_737() {
                
                _this.cLife.save(_this.lFile);
                _this.loadPage(Tonyu.classes.user.Files);
              })});
              _this.pa=new Tonyu.classes.kernel.Panel({x: Tonyu.globals.$w/2,y: Tonyu.globals.$h/2,width: _this.rc*_this.size,height: _this.rc*_this.size});
              _this.pa.on("touch",(function anonymous_976(e) {
                var f;
                var val;
                
                f = e.finger;
                
                _this.px=_this.py=null;
                val = _this.putChipByFinger(f);
                
                f.on("move",(function anonymous_1086(e) {
                  var f;
                  
                  f = e.finger;
                  
                  _this.putChipByFinger(f,val);
                }));
              }));
              _this.padding={w: (Tonyu.globals.$w-_this.rc*_this.size)/2,h: (Tonyu.globals.$h-_this.rc*_this.size)/2};
              _this.i=0;
            case 1:
              if (!(_this.i<_this.rc)) { __pc=7     ; break; }
              _this.j=0;
            case 2:
              if (!(_this.j<_this.rc)) { __pc=5     ; break; }
              _this.fiber$putChip(_thread, _this.i, _this.j, _this.mat.get(_this.j,_this.i)==1);
              __pc=3;return;
            case 3:
              
            case 4     :
              _this.j++;
              __pc=2;break;
            case 5     :
              
            case 6     :
              _this.i++;
              __pc=1;break;
            case 7     :
              
              _thread.exit(_this);return;
            }
          }
        });
      },
      putChipByFinger :function _trc_Graph_putChipByFinger(f,val) {
        "use strict";
        var _this=this;
        var m;
        var cy;
        var cx;
        
        f.layer=Tonyu.globals.$mainLayer;
        m = _this.pa.convert(f,_this.pa);
        
        cy = _this.floor(m.y/_this.size);
        cx = _this.floor(m.x/_this.size);
        
        if (_this.px!=null&&_this.py!=null) {
          _this.lineChip(_this.px,_this.py,cx,cy,val);
          _this.px=cx;
          _this.py=cy;
          return _this;
          
        }
        _this.px=cx;
        _this.py=cy;
        return _this.putChip(cy,cx,val);
      },
      fiber$putChipByFinger :function _trc_Graph_f_putChipByFinger(_thread,f,val) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var m;
        var cy;
        var cx;
        
        f.layer=Tonyu.globals.$mainLayer;
        m = _this.pa.convert(f,_this.pa);
        
        cy = _this.floor(m.y/_this.size);
        cx = _this.floor(m.x/_this.size);
        
        
        _thread.enter(function _trc_Graph_ent_putChipByFinger(_thread) {
          if (_thread.lastEx) __pc=_thread.catchPC;
          for(var __cnt=100 ; __cnt--;) {
            switch (__pc) {
            case 0:
              if (!(_this.px!=null&&_this.py!=null)) { __pc=2     ; break; }
              _this.fiber$lineChip(_thread, _this.px, _this.py, cx, cy, val);
              __pc=1;return;
            case 1:
              
              _this.px=cx;
              _this.py=cy;
              _thread.exit(_this);return;
            case 2     :
              
              _this.px=cx;
              _this.py=cy;
              _this.fiber$putChip(_thread, cy, cx, val);
              __pc=3;return;
            case 3:
              _thread.exit(_thread.retVal);return;
              
              _thread.exit(_this);return;
            }
          }
        });
      },
      lineChip :function _trc_Graph_lineChip(sx,sy,dx,dy,on) {
        "use strict";
        var _this=this;
        var x;
        var y;
        var _it_568;
        
        _it_568=Tonyu.iterator(new Tonyu.classes.user.Line({x: sx,y: sy},{x: dx,y: dy}),2);
        while(_it_568.next()) {
          x=_it_568[0];
          y=_it_568[1];
          
          _this.putChip(y,x,on);
          
        }
      },
      fiber$lineChip :function _trc_Graph_f_lineChip(_thread,sx,sy,dx,dy,on) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var x;
        var y;
        var _it_568;
        
        
        _thread.enter(function _trc_Graph_ent_lineChip(_thread) {
          if (_thread.lastEx) __pc=_thread.catchPC;
          for(var __cnt=100 ; __cnt--;) {
            switch (__pc) {
            case 0:
              _it_568=Tonyu.iterator(new Tonyu.classes.user.Line({x: sx,y: sy},{x: dx,y: dy}),2);
            case 1:
              if (!(_it_568.next())) { __pc=3     ; break; }
              x=_it_568[0];
              y=_it_568[1];
              
              _this.fiber$putChip(_thread, y, x, on);
              __pc=2;return;
            case 2:
              
              __pc=1;break;
            case 3     :
              
              _thread.exit(_this);return;
            }
          }
        });
      },
      putChip :function _trc_Graph_putChip(row,col,on) {
        "use strict";
        var _this=this;
        
        if (row!==row||typeof  row!=="number") {
          throw new Error("row "+row);
          
        }
        if (col!==col||typeof  col!=="number") {
          throw new Error("col "+col);
          
        }
        if (on==null) {
          on=! _this.mat.get(col,row);
          
        }
        _this.mat.set(col,row,on);
        _this.pa.fillStyle=on?"#fff":"#888";
        _this.pa.fillRect(col*_this.size,row*_this.size,_this.size-1,_this.size-1);
        return on;
      },
      fiber$putChip :function _trc_Graph_f_putChip(_thread,row,col,on) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        if (row!==row||typeof  row!=="number") {
          throw new Error("row "+row);
          
        }
        if (col!==col||typeof  col!=="number") {
          throw new Error("col "+col);
          
        }
        if (on==null) {
          on=! _this.mat.get(col,row);
          
        }
        _this.mat.set(col,row,on);
        _this.pa.fillStyle=on?"#fff":"#888";
        _this.pa.fillRect(col*_this.size,row*_this.size,_this.size-1,_this.size-1);
        _thread.retVal=on;return;
        
        
        _thread.retVal=_this;return;
      },
      __dummy: false
    };
  },
  decls: {"methods":{"main":{"nowait":false},"putChipByFinger":{"nowait":false},"lineChip":{"nowait":false},"putChip":{"nowait":false}},"fields":{"rc":{},"cLife":{},"lFile":{},"mat":{},"nlbl":{},"pa":{},"px":{},"py":{},"padding":{},"i":{},"j":{}}}
});
Tonyu.klass.define({
  fullName: 'user.Letters',
  shortName: 'Letters',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.Actor,
  includes: [],
  methods: function (__superClass) {
    return {
      main :function _trc_Letters_main() {
        "use strict";
        var _this=this;
        
        _this.str = "佐藤鈴木高橋田中伊渡辺山本村小林加吉々口松井上斎清水崎森池阿部石川下島"+"前岡長谷後近遠青坂斉福太西金子原野三浦竹内和柴酒宮横安大今工増丸杉塚新平河武"+"千葉岩菅久保尾市菊地古桜飯北五十嵐関服東土屋辻樋秋永馬場浜星矢浅荒熊黒望月堀"+"早栗広瀬萩片間須鎌篠賀泉成南奥沢桑宅富八根合牧白寺倉渋足立天多豊角榎神児玉齋"+"笠植稲垣若及代嶋江岸細戸達津落町畠堤米好伯甲斐徳榊梅城滝端梶比嘉庄司茂荻日向"+"宇丹羽柳緒方亀輪窪澤出志臼溝筒奧冨手入湯鶴沼槻二相園柏花納桐海元越智畑邊深";
        
        _this.f = 16;
        
        
        
        _this.loadJSON();
        _this.fireEvent("ready");
      },
      fiber$main :function _trc_Letters_f_main(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        _this.str = "佐藤鈴木高橋田中伊渡辺山本村小林加吉々口松井上斎清水崎森池阿部石川下島"+"前岡長谷後近遠青坂斉福太西金子原野三浦竹内和柴酒宮横安大今工増丸杉塚新平河武"+"千葉岩菅久保尾市菊地古桜飯北五十嵐関服東土屋辻樋秋永馬場浜星矢浅荒熊黒望月堀"+"早栗広瀬萩片間須鎌篠賀泉成南奥沢桑宅富八根合牧白寺倉渋足立天多豊角榎神児玉齋"+"笠植稲垣若及代嶋江岸細戸達津落町畠堤米好伯甲斐徳榊梅城滝端梶比嘉庄司茂荻日向"+"宇丹羽柳緒方亀輪窪澤出志臼溝筒奧冨手入湯鶴沼槻二相園柏花納桐海元越智畑邊深";
        
        _this.f = 16;
        
        
        
        
        _thread.enter(function _trc_Letters_ent_main(_thread) {
          if (_thread.lastEx) __pc=_thread.catchPC;
          for(var __cnt=100 ; __cnt--;) {
            switch (__pc) {
            case 0:
              _this.fiber$loadJSON(_thread);
              __pc=1;return;
            case 1:
              
              _this.fireEvent("ready");
              _thread.exit(_this);return;
            }
          }
        });
      },
      save :function _trc_Letters_save() {
        "use strict";
        var _this=this;
        var i;
        
        _this.p=new Tonyu.classes.kernel.Panel({width: 256,height: 256});
        _this.c=_this.p.context;
        _this.c.font=_this.f+"px ＭＳ 明朝";
        _this.c.textBaseline="top";
        _this.c.fillStyle="white";
        i = 0;
        for (; i<16 ; i++) {
          {
            _this.p.fillText(_this.str.substring(i*16,i*16+16),0,i*16,16,"left","top");
            _this.p.fillText(_this.str.substring(i*16,i*16+16),1,i*16,16,"left","top");
          }
        }
        _this.p.save("font.png");
      },
      fiber$save :function _trc_Letters_f_save(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var i;
        
        _this.p=new Tonyu.classes.kernel.Panel({width: 256,height: 256});
        _this.c=_this.p.context;
        _this.c.font=_this.f+"px ＭＳ 明朝";
        _this.c.textBaseline="top";
        _this.c.fillStyle="white";
        i = 0;
        for (; i<16 ; i++) {
          {
            _this.p.fillText(_this.str.substring(i*16,i*16+16),0,i*16,16,"left","top");
            _this.p.fillText(_this.str.substring(i*16,i*16+16),1,i*16,16,"left","top");
          }
        }
        _this.p.save("font.png");
        
        _thread.retVal=_this;return;
      },
      load :function _trc_Letters_load() {
        "use strict";
        var _this=this;
        
        _this.p=new Tonyu.classes.kernel.Panel;
        _this.waitFor(_this.p.load("font.png"));
        _this.p.alpha=0;
      },
      fiber$load :function _trc_Letters_f_load(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        _this.p=new Tonyu.classes.kernel.Panel;
        
        _thread.enter(function _trc_Letters_ent_load(_thread) {
          if (_thread.lastEx) __pc=_thread.catchPC;
          for(var __cnt=100 ; __cnt--;) {
            switch (__pc) {
            case 0:
              _this.fiber$waitFor(_thread, _this.p.load("font.png"));
              __pc=1;return;
            case 1:
              
              _this.p.alpha=0;
              _thread.exit(_this);return;
            }
          }
        });
      },
      getPat :function _trc_Letters_getPat(s) {
        "use strict";
        var _this=this;
        var i;
        var c;
        var r;
        var d;
        var y;
        var x;
        
        if (_this.c2p&&_this.c2p[s]) {
          return _this.c2p[s];
        }
        i = _this.str.indexOf(s);
        
        c = i%16;
        r = _this.floor(i/16);
        
        d = _this.p.getImageData(c*16,r*16,16,16).data;
        
        r = new Tonyu.classes.kernel.Matrix;
        
        y = 0;
        for (; y<_this.f ; y++) {
          {
            x = 0;
            for (; x<_this.f ; x++) {
              {
                if (d[(y*_this.f+x)*4+3]>0) {
                  r.set(x,y,1);
                  
                }
              }
            }
          }
        }
        return r;
      },
      fiber$getPat :function _trc_Letters_f_getPat(_thread,s) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var i;
        var c;
        var r;
        var d;
        var y;
        var x;
        
        if (_this.c2p&&_this.c2p[s]) {
          _thread.retVal=_this.c2p[s];return;
          
        }
        i = _this.str.indexOf(s);
        
        c = i%16;
        r = _this.floor(i/16);
        
        d = _this.p.getImageData(c*16,r*16,16,16).data;
        
        r = new Tonyu.classes.kernel.Matrix;
        
        y = 0;
        for (; y<_this.f ; y++) {
          {
            x = 0;
            for (; x<_this.f ; x++) {
              {
                if (d[(y*_this.f+x)*4+3]>0) {
                  r.set(x,y,1);
                  
                }
              }
            }
          }
        }
        _thread.retVal=r;return;
        
        
        _thread.retVal=_this;return;
      },
      nameList :function _trc_Letters_nameList() {
        "use strict";
        var _this=this;
        var res;
        var line;
        var _it_579;
        
        res = [];
        
        _it_579=Tonyu.iterator(_this.file("../static/names.txt").lines(),1);
        while(_it_579.next()) {
          line=_it_579[0];
          
          if (line.length==2) {
            res.push(line);
            
          }
          
        }
        return res;
      },
      fiber$nameList :function _trc_Letters_f_nameList(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var res;
        var line;
        var _it_579;
        
        res = [];
        
        _it_579=Tonyu.iterator(_this.file("../static/names.txt").lines(),1);
        while(_it_579.next()) {
          line=_it_579[0];
          
          if (line.length==2) {
            res.push(line);
            
          }
          
        }
        _thread.retVal=res;return;
        
        
        _thread.retVal=_this;return;
      },
      loadJSON :function _trc_Letters_loadJSON() {
        "use strict";
        var _this=this;
        var k;
        var _it_583;
        var a;
        var i;
        
        _this.c2p=_this.file("../static/font.json").obj();
        _it_583=Tonyu.iterator(_this.c2p,1);
        while(_it_583.next()) {
          k=_it_583[0];
          
          a = _this.c2p[k];
          
          _this.c2p[k]=new Tonyu.classes.kernel.Matrix;
          i = 0;
          for (; i<a.length ; i+=2) {
            {
              _this.c2p[k].set(a[i],a[i+1],1);
            }
          }
          
        }
      },
      fiber$loadJSON :function _trc_Letters_f_loadJSON(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var k;
        var _it_583;
        var a;
        var i;
        
        _this.c2p=_this.file("../static/font.json").obj();
        _it_583=Tonyu.iterator(_this.c2p,1);
        while(_it_583.next()) {
          k=_it_583[0];
          
          a = _this.c2p[k];
          
          _this.c2p[k]=new Tonyu.classes.kernel.Matrix;
          i = 0;
          for (; i<a.length ; i+=2) {
            {
              _this.c2p[k].set(a[i],a[i+1],1);
            }
          }
          
        }
        
        _thread.retVal=_this;return;
      },
      toJSON :function _trc_Letters_toJSON() {
        "use strict";
        var _this=this;
        var res;
        var i;
        var m;
        var xys;
        var x;
        var y;
        var c;
        var _it_588;
        
        res = {};
        
        i = 0;
        for (; i<_this.str.length ; i++) {
          {
            m = _this.getPat(_this.str[i]);
            
            xys = [];
            
            res[_this.str[i]]=xys;
            _it_588=Tonyu.iterator(m,3);
            while(_it_588.next()) {
              x=_it_588[0];
              y=_it_588[1];
              c=_it_588[2];
              
              if (! c) {
                continue;
                
              }
              xys.push(x);
              xys.push(y);
              
            }
          }
        }
        _this.file("font.json").obj(res);
      },
      fiber$toJSON :function _trc_Letters_f_toJSON(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var res;
        var i;
        var m;
        var xys;
        var x;
        var y;
        var c;
        var _it_588;
        
        res = {};
        
        
        _thread.enter(function _trc_Letters_ent_toJSON(_thread) {
          if (_thread.lastEx) __pc=_thread.catchPC;
          for(var __cnt=100 ; __cnt--;) {
            switch (__pc) {
            case 0:
              i = 0;
              
            case 1:
              if (!(i<_this.str.length)) { __pc=4     ; break; }
              _this.fiber$getPat(_thread, _this.str[i]);
              __pc=2;return;
            case 2:
              m=_thread.retVal;
              
              xys = [];
              
              res[_this.str[i]]=xys;
              _it_588=Tonyu.iterator(m,3);
              while(_it_588.next()) {
                x=_it_588[0];
                y=_it_588[1];
                c=_it_588[2];
                
                if (! c) {
                  continue;
                  
                }
                xys.push(x);
                xys.push(y);
                
              }
            case 3     :
              i++;
              __pc=1;break;
            case 4     :
              
              _this.file("font.json").obj(res);
              _thread.exit(_this);return;
            }
          }
        });
      },
      __dummy: false
    };
  },
  decls: {"methods":{"main":{"nowait":false},"save":{"nowait":false},"load":{"nowait":false},"getPat":{"nowait":false},"nameList":{"nowait":false},"loadJSON":{"nowait":false},"toJSON":{"nowait":false}},"fields":{"str":{},"f":{},"c2p":{},"p":{},"c":{}}}
});
Tonyu.klass.define({
  fullName: 'user.Line',
  shortName: 'Line',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.TObject,
  includes: [Tonyu.classes.kernel.MathMod],
  methods: function (__superClass) {
    return {
      main :function _trc_Line_main() {
        "use strict";
        var _this=this;
        
      },
      fiber$main :function _trc_Line_f_main(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        
        _thread.retVal=_this;return;
      },
      initialize :function _trc_Line_initialize(src,dst) {
        "use strict";
        var _this=this;
        var dx;
        var dy;
        
        _this.src=src;
        _this.dst=dst;
        dx = dst.x-src.x;
        
        dy = dst.y-src.y;
        
        if (dx===0&&dy===0) {
          _this.length=1;
          _this.vel={x: 0,y: 0};
          
        } else {
          if (_this.abs(dx)>_this.abs(dy)) {
            _this.length=_this.abs(dx)+1;
            _this.vel={x: _this.sgn(dx),y: dy/(_this.length-1)};
            
          } else {
            _this.length=_this.abs(dy)+1;
            _this.vel={y: _this.sgn(dy),x: dx/(_this.length-1)};
            
          }
        }
        _this.i=0;
      },
      tonyuIterator :function _trc_Line_tonyuIterator(arity) {
        "use strict";
        var _this=this;
        var it;
        
        it = {};
        
        it.next=(function anonymous_456() {
          
          if (_this.i>=_this.length) {
            return false;
          }
          if (arity==1) {
            it[0]={x: _this.floor(_this.src.x+_this.vel.x*_this.i),y: _this.floor(_this.src.y+_this.vel.y*_this.i)};
            
          } else {
            it[0]=_this.floor(_this.src.x+_this.vel.x*_this.i);
            it[1]=_this.floor(_this.src.y+_this.vel.y*_this.i);
            
          }
          _this.i++;
          return true;
        });
        return it;
      },
      fiber$tonyuIterator :function _trc_Line_f_tonyuIterator(_thread,arity) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var it;
        
        it = {};
        
        it.next=(function anonymous_456() {
          
          if (_this.i>=_this.length) {
            return false;
          }
          if (arity==1) {
            it[0]={x: _this.floor(_this.src.x+_this.vel.x*_this.i),y: _this.floor(_this.src.y+_this.vel.y*_this.i)};
            
          } else {
            it[0]=_this.floor(_this.src.x+_this.vel.x*_this.i);
            it[1]=_this.floor(_this.src.y+_this.vel.y*_this.i);
            
          }
          _this.i++;
          return true;
        });
        _thread.retVal=it;return;
        
        
        _thread.retVal=_this;return;
      },
      __dummy: false
    };
  },
  decls: {"methods":{"main":{"nowait":false},"new":{"nowait":false},"tonyuIterator":{"nowait":false}},"fields":{"length":{},"vel":{},"i":{},"src":{}}}
});
Tonyu.klass.define({
  fullName: 'user.LMatrix',
  shortName: 'LMatrix',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.TObject,
  includes: [],
  methods: function (__superClass) {
    return {
      main :function _trc_LMatrix_main() {
        "use strict";
        var _this=this;
        
      },
      fiber$main :function _trc_LMatrix_f_main(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        
        _thread.retVal=_this;return;
      },
      initialize :function _trc_LMatrix_initialize(_extend) {
        "use strict";
        var _this=this;
        
        _this.extend(_extend);
        _this.ary=[];
      },
      get :function _trc_LMatrix_get(x,y) {
        "use strict";
        var _this=this;
        
        x=(x+_this.col)%_this.col;
        y=(y+_this.row)%_this.row;
        return _this.ary[y*_this.col+x];
      },
      fiber$get :function _trc_LMatrix_f_get(_thread,x,y) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        x=(x+_this.col)%_this.col;
        y=(y+_this.row)%_this.row;
        _thread.retVal=_this.ary[y*_this.col+x];return;
        
        
        _thread.retVal=_this;return;
      },
      set :function _trc_LMatrix_set(x,y,c) {
        "use strict";
        var _this=this;
        var was;
        
        was = _this.ary[y*_this.col+x];
        
        if (was===c) {
          return _this;
        }
        _this.ary[y*_this.col+x]=c;
      },
      fiber$set :function _trc_LMatrix_f_set(_thread,x,y,c) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var was;
        
        was = _this.ary[y*_this.col+x];
        
        if (was===c) {
          _thread.retVal=_this;return;
          
        }
        _this.ary[y*_this.col+x]=c;
        
        _thread.retVal=_this;return;
      },
      __dummy: false
    };
  },
  decls: {"methods":{"main":{"nowait":false},"new":{"nowait":false},"get":{"nowait":false},"set":{"nowait":false}},"fields":{"ary":{},"col":{},"row":{}}}
});
Tonyu.klass.define({
  fullName: 'user.Main',
  shortName: 'Main',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.Actor,
  includes: [],
  methods: function (__superClass) {
    return {
      main :function _trc_Main_main() {
        "use strict";
        var _this=this;
        
        "field strict";
        Tonyu.globals.$Boot.setFrameRate(60);
        Tonyu.globals.$Screen.setBGColor("black");
        Tonyu.globals.$selected=["奥村","藤原"];
        ;
        
        Tonyu.globals.$r=36;
        Tonyu.globals.$c=35;
        Tonyu.globals.$p=6;
        Tonyu.globals.$Screen.resize(Tonyu.globals.$c*Tonyu.globals.$p,Tonyu.globals.$r*Tonyu.globals.$p);
        Tonyu.globals.$w=Tonyu.globals.$screenWidth;
        Tonyu.globals.$h=Tonyu.globals.$screenHeight;
        
        _this.n = new Tonyu.classes.user.Letters;
        
        _this.waitEvent(_this.n,"ready");
        _this.nl = _this.n.nameList();
        
        
        _this.sel1 = _this.rnd(_this.nl.length-1);
        
        _this.sel2 = _this.rnd(_this.nl.length-_this.sel1)+_this.sel1;
        
        _this.names=_this.names||[_this.nl[_this.sel1],_this.nl[_this.sel2]];
        _this.clives = [];
        
        _this.i = 0;
        for (; _this.i<2 ; _this.i++) {
          {
            _this.c = new Tonyu.classes.user.CLife({name: _this.names[_this.i]});
            
            _this.c.load(_this.n);
            _this.clives.push(_this.c);
          }
        }
        Tonyu.globals.$cname=_this.clives?_this.clives.map((function anonymous_742(c) {
          
          return c.name;
        })):["Red","Blue","Green","Aqua","Yellow","Purple"];
        _this.c = new Tonyu.classes.user.Cells;
        
        _this.init();
        _this.hist = [0,0,0,0,0,0,0,0,0,0,0,0,0];
        
        _this.life = _this.hist.length;
        
        _this.update();
        _this.alr = _this.readAlready();
        
        _this.alr[_this.alKey(_this.names[0],_this.names[1])]=1;
        _this.updateEx(30);
        _this.c.sendEvent("start");
        _this.update();
        _this.gen = 0;
        
        _this.status = new Tonyu.classes.kernel.Label({x: 100,y: 20,size: 8});
        
        _this.statSums = [0,0,0,0];
        
        while (true) {
          _this.s = _this.c.sum;
          
          _this.isp = ! _this.test&&_this.isPerfect();
          
          if (_this.hist.indexOf(_this.s)>=0||_this.isp) {
            _this.life--;
            if (_this.life<0||_this.isp) {
              _this.r = _this.judge();
              
              if (Tonyu.globals.$test) {
                if (Tonyu.globals.$nextURL) {
                  new Tonyu.classes.kernel.Button({top: Tonyu.globals.$h-50,height: 30,text: "Next",onClick: (function anonymous_1701() {
                    
                    Tonyu.globals.$WebPage.open(Tonyu.globals.$nextURL);
                  })});
                  
                }
                while (true) {
                  _this.update();
                }
                
              } else {
                if (_this.clives) {
                  _this.i = 0;
                  
                  _this.s = _this.c.colStat;
                  
                  if ((_this.s[0]+_this.s[1])>(_this.s[2]+_this.s[3])) {
                    _this.names[1]=_this.sel();
                    
                  } else {
                    _this.names[0]=_this.sel();
                    
                  }
                  while (true) {
                    _this.sel1=_this.nl.indexOf(_this.names[0]);
                    _this.sel2=_this.nl.indexOf(_this.names[1]);
                    if (_this.sel1==_this.sel2||_this.alr[_this.alKey(_this.names[0],_this.names[1])]) {
                      _this.sel1=_this.rnd(_this.nl.length-1);
                      _this.sel2=_this.rnd(_this.nl.length-_this.sel1)+_this.sel1;
                      _this.names=[_this.nl[_this.sel1],_this.nl[_this.sel2]];
                      if (_this.i<30) {
                        _this.update();
                      }
                      _this.i++;
                      continue;
                      
                      
                    }
                    break;
                    
                    
                  }
                  _this.loadPage(Tonyu.classes.user.Main,{names: _this.names});
                  
                } else {
                  _this.gov = new Tonyu.classes.kernel.Actor({x: Tonyu.globals.$screenWidth/2,y: Tonyu.globals.$screenHeight/2,size: 30,text: Tonyu.globals.$cname[_this.r]+" Win!"});
                  
                  _this.updateEx(60);
                  _this.init();
                  _this.gov.die();
                  _this.life=10;
                  
                }
                
              }
              
            }
            
          } else {
            _this.life=_this.hist.length;
            
          }
          _this.hist.push(_this.s);
          _this.hist.shift();
          _this.gen++;
          _this.status.text="第"+_this.gen+"世代, "+Object.keys(_this.alr).length;
          if (_this.c.colStat) {
            _this.i = 0;
            for (; _this.i<_this.statSums.length ; _this.i++) {
              {
                _this.statSums[_this.i]+=_this.c.colStat[_this.i];
              }
            }
            
          }
          _this.update();
          
        }
      },
      fiber$main :function _trc_Main_f_main(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        "field strict";
        Tonyu.globals.$Boot.setFrameRate(60);
        Tonyu.globals.$Screen.setBGColor("black");
        Tonyu.globals.$selected=["奥村","藤原"];
        ;
        
        Tonyu.globals.$r=36;
        Tonyu.globals.$c=35;
        Tonyu.globals.$p=6;
        Tonyu.globals.$Screen.resize(Tonyu.globals.$c*Tonyu.globals.$p,Tonyu.globals.$r*Tonyu.globals.$p);
        Tonyu.globals.$w=Tonyu.globals.$screenWidth;
        Tonyu.globals.$h=Tonyu.globals.$screenHeight;
        
        _this.n = new Tonyu.classes.user.Letters;
        
        
        _thread.enter(function _trc_Main_ent_main(_thread) {
          if (_thread.lastEx) __pc=_thread.catchPC;
          for(var __cnt=100 ; __cnt--;) {
            switch (__pc) {
            case 0:
              _this.fiber$waitEvent(_thread, _this.n, "ready");
              __pc=1;return;
            case 1:
              
              _this.nl = _this.n.nameList();
              
              
              _this.sel1 = _this.rnd(_this.nl.length-1);
              
              _this.sel2 = _this.rnd(_this.nl.length-_this.sel1)+_this.sel1;
              
              _this.names=_this.names||[_this.nl[_this.sel1],_this.nl[_this.sel2]];
              _this.clives = [];
              
              _this.i = 0;
              for (; _this.i<2 ; _this.i++) {
                {
                  _this.c = new Tonyu.classes.user.CLife({name: _this.names[_this.i]});
                  
                  _this.c.load(_this.n);
                  _this.clives.push(_this.c);
                }
              }
              Tonyu.globals.$cname=_this.clives?_this.clives.map((function anonymous_742(c) {
                
                return c.name;
              })):["Red","Blue","Green","Aqua","Yellow","Purple"];
              _this.c = new Tonyu.classes.user.Cells;
              
              _this.fiber$init(_thread);
              __pc=2;return;
            case 2:
              
              _this.hist = [0,0,0,0,0,0,0,0,0,0,0,0,0];
              
              _this.life = _this.hist.length;
              
              _this.fiber$update(_thread);
              __pc=3;return;
            case 3:
              
              _this.fiber$readAlready(_thread);
              __pc=4;return;
            case 4:
              _this.alr=_thread.retVal;
              
              _this.alr[_this.alKey(_this.names[0],_this.names[1])]=1;
              _this.fiber$updateEx(_thread, 30);
              __pc=5;return;
            case 5:
              
              _this.c.sendEvent("start");
              _this.fiber$update(_thread);
              __pc=6;return;
            case 6:
              
              _this.gen = 0;
              
              _this.status = new Tonyu.classes.kernel.Label({x: 100,y: 20,size: 8});
              
              _this.statSums = [0,0,0,0];
              
            case 7:
              _this.s = _this.c.sum;
              
              _this.isp = ! _this.test&&_this.isPerfect();
              
              if (!(_this.hist.indexOf(_this.s)>=0||_this.isp)) { __pc=29    ; break; }
              _this.life--;
              if (!(_this.life<0||_this.isp)) { __pc=28    ; break; }
              _this.fiber$judge(_thread);
              __pc=8;return;
            case 8:
              _this.r=_thread.retVal;
              
              if (!(Tonyu.globals.$test)) { __pc=12    ; break; }
              if (Tonyu.globals.$nextURL) {
                new Tonyu.classes.kernel.Button({top: Tonyu.globals.$h-50,height: 30,text: "Next",onClick: (function anonymous_1701() {
                  
                  Tonyu.globals.$WebPage.open(Tonyu.globals.$nextURL);
                })});
                
              }
            case 9:
              _this.fiber$update(_thread);
              __pc=10;return;
            case 10:
              
              __pc=9;break;
            case 11    :
              
              __pc=27    ;break;
            case 12    :
              if (!(_this.clives)) { __pc=23    ; break; }
              _this.i = 0;
              
              _this.s = _this.c.colStat;
              
              if (!((_this.s[0]+_this.s[1])>(_this.s[2]+_this.s[3]))) { __pc=14    ; break; }
              _this.fiber$sel(_thread);
              __pc=13;return;
            case 13:
              _this.names[1]=_thread.retVal;
              
              __pc=16    ;break;
            case 14    :
              _this.fiber$sel(_thread);
              __pc=15;return;
            case 15:
              _this.names[0]=_thread.retVal;
              
            case 16    :
              
            case 17:
              _this.sel1=_this.nl.indexOf(_this.names[0]);
              _this.sel2=_this.nl.indexOf(_this.names[1]);
              if (!(_this.sel1==_this.sel2||_this.alr[_this.alKey(_this.names[0],_this.names[1])])) { __pc=20    ; break; }
              _this.sel1=_this.rnd(_this.nl.length-1);
              _this.sel2=_this.rnd(_this.nl.length-_this.sel1)+_this.sel1;
              _this.names=[_this.nl[_this.sel1],_this.nl[_this.sel2]];
              if (!(_this.i<30)) { __pc=19    ; break; }
              _this.fiber$update(_thread);
              __pc=18;return;
            case 18:
              
            case 19    :
              
              _this.i++;
              __pc=17; break;
              
            case 20    :
              
              __pc=21    ; break;
              
              __pc=17;break;
            case 21    :
              
              _this.fiber$loadPage(_thread, Tonyu.classes.user.Main, {names: _this.names});
              __pc=22;return;
            case 22:
              
              __pc=26    ;break;
            case 23    :
              _this.gov = new Tonyu.classes.kernel.Actor({x: Tonyu.globals.$screenWidth/2,y: Tonyu.globals.$screenHeight/2,size: 30,text: Tonyu.globals.$cname[_this.r]+" Win!"});
              
              _this.fiber$updateEx(_thread, 60);
              __pc=24;return;
            case 24:
              
              _this.fiber$init(_thread);
              __pc=25;return;
            case 25:
              
              _this.gov.die();
              _this.life=10;
            case 26    :
              
            case 27    :
              
            case 28    :
              
              __pc=30    ;break;
            case 29    :
              {
                _this.life=_this.hist.length;
              }
            case 30    :
              
              _this.hist.push(_this.s);
              _this.hist.shift();
              _this.gen++;
              _this.status.text="第"+_this.gen+"世代, "+Object.keys(_this.alr).length;
              if (_this.c.colStat) {
                _this.i = 0;
                for (; _this.i<_this.statSums.length ; _this.i++) {
                  {
                    _this.statSums[_this.i]+=_this.c.colStat[_this.i];
                  }
                }
                
              }
              _this.fiber$update(_thread);
              __pc=31;return;
            case 31:
              
              __pc=7;break;
            case 32    :
              
              _thread.exit(_this);return;
            }
          }
        });
      },
      sel :function _trc_Main_sel() {
        "use strict";
        var _this=this;
        var r;
        
        
        switch (_this.rnd(2)) {
        case 0:
          return Tonyu.globals.$selected[_this.rnd(Tonyu.globals.$selected.length)];
        default:
          return _this.nl[_this.rnd(_this.nl.length)];
        }
      },
      fiber$sel :function _trc_Main_f_sel(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var r;
        
        
        switch (_this.rnd(2)) {
        case 0:
          _thread.retVal=Tonyu.globals.$selected[_this.rnd(Tonyu.globals.$selected.length)];return;
          
        default:
          _thread.retVal=_this.nl[_this.rnd(_this.nl.length)];return;
          
        }
        
        _thread.retVal=_this;return;
      },
      isPerfect :function _trc_Main_isPerfect() {
        "use strict";
        var _this=this;
        var s;
        
        s = _this.c.colStat;
        
        return s&&! ((s[0]+s[1])*(s[2]+s[3]));
      },
      fiber$isPerfect :function _trc_Main_f_isPerfect(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var s;
        
        s = _this.c.colStat;
        
        _thread.retVal=s&&! ((s[0]+s[1])*(s[2]+s[3]));return;
        
        
        _thread.retVal=_this;return;
      },
      init :function _trc_Main_init() {
        "use strict";
        var _this=this;
        var sx;
        var sy;
        var i;
        var j;
        var fsize;
        var idx;
        
        if (_this.test) {
          sx = _this.floor((Tonyu.globals.$c-_this.test.xmax)/2);
          
          sy = _this.floor((Tonyu.globals.$r-_this.test.ymax)/2);
          
          i = 0;
          for (; i<Tonyu.globals.$r ; i++) {
            {
              j = 0;
              for (; j<Tonyu.globals.$c ; j++) {
                {
                  if (_this.test.get(j-sx,i-sy)) {
                    _this.c.cur.set(j,i,1);
                    
                  } else {
                    _this.c.cur.set(j,i,0);
                    
                  }
                }
              }
            }
          }
          new Tonyu.classes.kernel.Button({text: "return",top: Tonyu.globals.$h-30,height: 30,onClick: (function anonymous_4221() {
            
            _this.loadPage();
          })});
          
        } else {
          if (_this.clives) {
            fsize = Tonyu.globals.$r/2;
            
            i = 0;
            for (; i<Tonyu.globals.$r ; i++) {
              {
                j = 0;
                for (; j<Tonyu.globals.$c ; j++) {
                  {
                    idx = _this.floor(i/fsize);
                    
                    sx = j;
                    
                    sy = i%fsize;
                    
                    _this.c.cur.set(j,i,(_this.clives[idx].mat.get(sx-2,sy-2)?1:0)+idx*2);
                  }
                }
              }
            }
            
          } else {
            i = 0;
            for (; i<Tonyu.globals.$r ; i++) {
              {
                j = 0;
                for (; j<Tonyu.globals.$c ; j++) {
                  {
                    _this.c.cur.set(j,i,_this.rnd(2)+(_this.floor(j*2/Tonyu.globals.$c)*2)+(_this.floor(i*3/Tonyu.globals.$r)*4));
                  }
                }
              }
            }
            
          }
        }
      },
      fiber$init :function _trc_Main_f_init(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var sx;
        var sy;
        var i;
        var j;
        var fsize;
        var idx;
        
        
        _thread.enter(function _trc_Main_ent_init(_thread) {
          if (_thread.lastEx) __pc=_thread.catchPC;
          for(var __cnt=100 ; __cnt--;) {
            switch (__pc) {
            case 0:
              if (!(_this.test)) { __pc=1     ; break; }
              sx = _this.floor((Tonyu.globals.$c-_this.test.xmax)/2);
              
              sy = _this.floor((Tonyu.globals.$r-_this.test.ymax)/2);
              
              i = 0;
              for (; i<Tonyu.globals.$r ; i++) {
                {
                  j = 0;
                  for (; j<Tonyu.globals.$c ; j++) {
                    {
                      if (_this.test.get(j-sx,i-sy)) {
                        _this.c.cur.set(j,i,1);
                        
                      } else {
                        _this.c.cur.set(j,i,0);
                        
                      }
                    }
                  }
                }
              }
              new Tonyu.classes.kernel.Button({text: "return",top: Tonyu.globals.$h-30,height: 30,onClick: (function anonymous_4221() {
                
                _this.loadPage();
              })});
              __pc=2     ;break;
            case 1     :
              if (_this.clives) {
                fsize = Tonyu.globals.$r/2;
                
                i = 0;
                for (; i<Tonyu.globals.$r ; i++) {
                  {
                    j = 0;
                    for (; j<Tonyu.globals.$c ; j++) {
                      {
                        idx = _this.floor(i/fsize);
                        
                        sx = j;
                        
                        sy = i%fsize;
                        
                        _this.c.cur.set(j,i,(_this.clives[idx].mat.get(sx-2,sy-2)?1:0)+idx*2);
                      }
                    }
                  }
                }
                
              } else {
                i = 0;
                for (; i<Tonyu.globals.$r ; i++) {
                  {
                    j = 0;
                    for (; j<Tonyu.globals.$c ; j++) {
                      {
                        _this.c.cur.set(j,i,_this.rnd(2)+(_this.floor(j*2/Tonyu.globals.$c)*2)+(_this.floor(i*3/Tonyu.globals.$r)*4));
                      }
                    }
                  }
                }
                
              }
            case 2     :
              
              _thread.exit(_this);return;
            }
          }
        });
      },
      judge :function _trc_Main_judge() {
        "use strict";
        var _this=this;
        var s;
        var e;
        var _it_610;
        var i;
        var j;
        var co;
        var ix;
        var y;
        var _it_611;
        
        s = [];
        
        if (_this.clives) {
          _it_610=Tonyu.iterator(_this.clives,1);
          while(_it_610.next()) {
            e=_it_610[0];
            
            s.push({name: e.name,score: 0});
          }
          
        }
        i = 0;
        for (; i<Tonyu.globals.$r ; i++) {
          {
            j = 0;
            for (; j<Tonyu.globals.$c ; j++) {
              {
                co = _this.c.cur.get(j,i);
                
                ix = _this.floor(co/2);
                
                s[ix]=s[ix]||{name: Tonyu.globals.$cname[ix],score: 0};
                s[ix].score++;
              }
            }
          }
        }
        if (s[0].score<s[1].score) {
          s.push(s.shift());
          _this.statSums.push(_this.statSums.shift());
          _this.statSums.push(_this.statSums.shift());
          
        }
        if (_this.file("log.txt").exists()) {
          _this.file("log.txt").appendText([s[0].name,s[0].score,s[1].name,s[1].score,_this.gen].concat(_this.statSums.map((function anonymous_5570(e) {
            
            return e/(Tonyu.globals.$r*Tonyu.globals.$c*_this.gen);
          }))).join("\t")+"\n");
          
        }
        s=s.sort((function anonymous_5668(a,b) {
          
          return b.score-a.score;
        }));
        y = 50;
        
        _it_611=Tonyu.iterator(s,1);
        while(_it_611.next()) {
          e=_it_611[0];
          
          new Tonyu.classes.kernel.Label({text: e.name+" - "+e.score,x: 100,y: y});
          y+=30;
          
        }
        return s;
      },
      fiber$judge :function _trc_Main_f_judge(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var s;
        var e;
        var _it_610;
        var i;
        var j;
        var co;
        var ix;
        var y;
        var _it_611;
        
        s = [];
        
        if (_this.clives) {
          _it_610=Tonyu.iterator(_this.clives,1);
          while(_it_610.next()) {
            e=_it_610[0];
            
            s.push({name: e.name,score: 0});
          }
          
        }
        i = 0;
        for (; i<Tonyu.globals.$r ; i++) {
          {
            j = 0;
            for (; j<Tonyu.globals.$c ; j++) {
              {
                co = _this.c.cur.get(j,i);
                
                ix = _this.floor(co/2);
                
                s[ix]=s[ix]||{name: Tonyu.globals.$cname[ix],score: 0};
                s[ix].score++;
              }
            }
          }
        }
        if (s[0].score<s[1].score) {
          s.push(s.shift());
          _this.statSums.push(_this.statSums.shift());
          _this.statSums.push(_this.statSums.shift());
          
        }
        if (_this.file("log.txt").exists()) {
          _this.file("log.txt").appendText([s[0].name,s[0].score,s[1].name,s[1].score,_this.gen].concat(_this.statSums.map((function anonymous_5570(e) {
            
            return e/(Tonyu.globals.$r*Tonyu.globals.$c*_this.gen);
          }))).join("\t")+"\n");
          
        }
        s=s.sort((function anonymous_5668(a,b) {
          
          return b.score-a.score;
        }));
        y = 50;
        
        _it_611=Tonyu.iterator(s,1);
        while(_it_611.next()) {
          e=_it_611[0];
          
          new Tonyu.classes.kernel.Label({text: e.name+" - "+e.score,x: 100,y: y});
          y+=30;
          
        }
        _thread.retVal=s;return;
        
        
        _thread.retVal=_this;return;
      },
      readAlready :function _trc_Main_readAlready() {
        "use strict";
        var _this=this;
        var r;
        
        Tonyu.globals.$log1=Tonyu.globals.$log1||_this.readAlreadyF(_this.file("log1.txt"));
        r = Tonyu.globals.$log1;
        
        Object.assign(r,_this.readAlreadyF(_this.file("log.txt")));
        return r;
      },
      fiber$readAlready :function _trc_Main_f_readAlready(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var r;
        
        Tonyu.globals.$log1=Tonyu.globals.$log1||_this.readAlreadyF(_this.file("log1.txt"));
        r = Tonyu.globals.$log1;
        
        Object.assign(r,_this.readAlreadyF(_this.file("log.txt")));
        _thread.retVal=r;return;
        
        
        _thread.retVal=_this;return;
      },
      alKey :function _trc_Main_alKey(a,b) {
        "use strict";
        var _this=this;
        
        return (a>b?a+b:b+a);
      },
      fiber$alKey :function _trc_Main_f_alKey(_thread,a,b) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        _thread.retVal=(a>b?a+b:b+a);return;
        
        
        _thread.retVal=_this;return;
      },
      readAlreadyF :function _trc_Main_readAlreadyF(f) {
        "use strict";
        var _this=this;
        var r;
        var i;
        var line;
        var _it_625;
        var a;
        
        r = {};
        
        if (! f.exists()) {
          return r;
        }
        i = 0;
        
        _it_625=Tonyu.iterator(f.lines(),1);
        while(_it_625.next()) {
          line=_it_625[0];
          
          a = line.split("\t");
          
          r[_this.alKey(a[0],a[2])]=1;
          i++;
          
        }
        return r;
      },
      fiber$readAlreadyF :function _trc_Main_f_readAlreadyF(_thread,f) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var r;
        var i;
        var line;
        var _it_625;
        var a;
        
        r = {};
        
        if (! f.exists()) {
          _thread.retVal=r;return;
          
        }
        i = 0;
        
        _it_625=Tonyu.iterator(f.lines(),1);
        while(_it_625.next()) {
          line=_it_625[0];
          
          a = line.split("\t");
          
          r[_this.alKey(a[0],a[2])]=1;
          i++;
          
        }
        _thread.retVal=r;return;
        
        
        _thread.retVal=_this;return;
      },
      __dummy: false
    };
  },
  decls: {"methods":{"main":{"nowait":false},"sel":{"nowait":false},"isPerfect":{"nowait":false},"init":{"nowait":false},"judge":{"nowait":false},"readAlready":{"nowait":false},"alKey":{"nowait":false},"readAlreadyF":{"nowait":false}},"fields":{"test":{},"n":{},"nl":{},"names":{},"sel1":{},"sel2":{},"clives":{},"i":{},"c":{},"hist":{},"life":{},"alr":{},"gen":{},"status":{},"statSums":{},"s":{},"isp":{},"r":{},"gov":{}}}
});
Tonyu.klass.define({
  fullName: 'user.MapURL',
  shortName: 'MapURL',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.TObject,
  includes: [Tonyu.classes.kernel.FileMod,Tonyu.classes.kernel.EventMod],
  methods: function (__superClass) {
    return {
      main :function _trc_MapURL_main() {
        "use strict";
        var _this=this;
        
        "field strict";
        
        
        
      },
      fiber$main :function _trc_MapURL_f_main(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        "field strict";
        
        
        
        
        _thread.retVal=_this;return;
      },
      p2c :function _trc_MapURL_p2c(l,p) {
        "use strict";
        var _this=this;
        
        return Tonyu.globals.$patsCode[l].indexOf(p);
      },
      fiber$p2c :function _trc_MapURL_f_p2c(_thread,l,p) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        _thread.retVal=Tonyu.globals.$patsCode[l].indexOf(p);return;
        
        
        _thread.retVal=_this;return;
      },
      c2p :function _trc_MapURL_c2p(l,c) {
        "use strict";
        var _this=this;
        
        return Tonyu.globals.$patsCode[l][c];
      },
      fiber$c2p :function _trc_MapURL_f_c2p(_thread,l,c) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        _thread.retVal=Tonyu.globals.$patsCode[l][c];return;
        
        
        _thread.retVal=_this;return;
      },
      fromURL :function _trc_MapURL_fromURL(url) {
        "use strict";
        var _this=this;
        var zipDir;
        var zipF;
        
        url=_this.uncompURL(url);
        zipDir = _this.cleanZipFolder();
        
        zipF = _this.file("z.zip");
        
        zipF.dataURL(url);
        return Tonyu.globals.$Zip.unzip(zipF,zipDir).then((function anonymous_490() {
          var z;
          var buf;
          
          z = zipDir.listFiles()[0];
          
          buf = new Uint8Array(z.getBytes());
          
          return buf;
        }));
      },
      fiber$fromURL :function _trc_MapURL_f_fromURL(_thread,url) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var zipDir;
        var zipF;
        
        
        _thread.enter(function _trc_MapURL_ent_fromURL(_thread) {
          if (_thread.lastEx) __pc=_thread.catchPC;
          for(var __cnt=100 ; __cnt--;) {
            switch (__pc) {
            case 0:
              _this.fiber$uncompURL(_thread, url);
              __pc=1;return;
            case 1:
              url=_thread.retVal;
              
              _this.fiber$cleanZipFolder(_thread);
              __pc=2;return;
            case 2:
              zipDir=_thread.retVal;
              
              _this.fiber$file(_thread, "z.zip");
              __pc=3;return;
            case 3:
              zipF=_thread.retVal;
              
              zipF.dataURL(url);
              _thread.exit(Tonyu.globals.$Zip.unzip(zipF,zipDir).then((function anonymous_490() {
                var z;
                var buf;
                
                z = zipDir.listFiles()[0];
                
                buf = new Uint8Array(z.getBytes());
                
                return buf;
              })));return;
              _thread.exit(_this);return;
            }
          }
        });
      },
      waitP :function _trc_MapURL_waitP() {
        "use strict";
        var _this=this;
        
        return _this.runPromise((function anonymous_832(success,error) {
          
          setTimeout(success,10);
        }));
      },
      fiber$waitP :function _trc_MapURL_f_waitP(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        
        _thread.enter(function _trc_MapURL_ent_waitP(_thread) {
          if (_thread.lastEx) __pc=_thread.catchPC;
          for(var __cnt=100 ; __cnt--;) {
            switch (__pc) {
            case 0:
              _this.fiber$runPromise(_thread, (function anonymous_832(success,error) {
                
                setTimeout(success,10);
              }));
              __pc=1;return;
            case 1:
              _thread.exit(_thread.retVal);return;
              
              _thread.exit(_this);return;
            }
          }
        });
      },
      toURL :function _trc_MapURL_toURL(buf) {
        "use strict";
        var _this=this;
        var zipDir;
        var zipF;
        
        zipDir = _this.cleanZipFolder();
        
        zipF = _this.file("z.zip");
        
        return _this.waitP().then((function anonymous_995() {
          var name;
          
          name = name||"z";
          
          zipDir.rel(name).setBytes(new Uint8Array(buf).buffer);
          return Tonyu.globals.$Zip.zip(zipDir,zipF);
        })).then((function anonymous_1173() {
          var res;
          
          res = zipF.text();
          
          res=_this.compURL(res);
          console.log(res);
          return res;
        }));
      },
      fiber$toURL :function _trc_MapURL_f_toURL(_thread,buf) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var zipDir;
        var zipF;
        
        
        _thread.enter(function _trc_MapURL_ent_toURL(_thread) {
          if (_thread.lastEx) __pc=_thread.catchPC;
          for(var __cnt=100 ; __cnt--;) {
            switch (__pc) {
            case 0:
              _this.fiber$cleanZipFolder(_thread);
              __pc=1;return;
            case 1:
              zipDir=_thread.retVal;
              
              _this.fiber$file(_thread, "z.zip");
              __pc=2;return;
            case 2:
              zipF=_thread.retVal;
              
              _thread.exit(_this.waitP().then((function anonymous_995() {
                var name;
                
                name = name||"z";
                
                zipDir.rel(name).setBytes(new Uint8Array(buf).buffer);
                return Tonyu.globals.$Zip.zip(zipDir,zipF);
              })).then((function anonymous_1173() {
                var res;
                
                res = zipF.text();
                
                res=_this.compURL(res);
                console.log(res);
                return res;
              })));return;
              _thread.exit(_this);return;
            }
          }
        });
      },
      cleanZipFolder :function _trc_MapURL_cleanZipFolder() {
        "use strict";
        var _this=this;
        var res;
        var f;
        var _it_641;
        
        res = _this.file("z/");
        
        if (! res.exists()) {
          res.mkdir();
        }
        _it_641=Tonyu.iterator(res.listFiles(),1);
        while(_it_641.next()) {
          f=_it_641[0];
          
          f.rm();
          
        }
        return res;
      },
      fiber$cleanZipFolder :function _trc_MapURL_f_cleanZipFolder(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var res;
        var f;
        var _it_641;
        
        
        _thread.enter(function _trc_MapURL_ent_cleanZipFolder(_thread) {
          if (_thread.lastEx) __pc=_thread.catchPC;
          for(var __cnt=100 ; __cnt--;) {
            switch (__pc) {
            case 0:
              _this.fiber$file(_thread, "z/");
              __pc=1;return;
            case 1:
              res=_thread.retVal;
              
              if (! res.exists()) {
                res.mkdir();
              }
              _it_641=Tonyu.iterator(res.listFiles(),1);
              while(_it_641.next()) {
                f=_it_641[0];
                
                f.rm();
                
              }
              _thread.exit(res);return;
              _thread.exit(_this);return;
            }
          }
        });
      },
      compURL :function _trc_MapURL_compURL(url) {
        "use strict";
        var _this=this;
        
        url=url.replace(/^data:application\/zip;base64,/,"");
        url=url.replace(/AAA+/g,(function anonymous_1548(a) {
          var c;
          var buf;
          
          c = a.length;
          
          buf = "";
          
          while (c>0) {
            buf+="."+String.fromCharCode(65+c);
            if (c<=26) {
              c-=26;
            } else {
              c=0;
            }
            
          }
          return buf;
        }));
        return url;
      },
      fiber$compURL :function _trc_MapURL_f_compURL(_thread,url) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        url=url.replace(/^data:application\/zip;base64,/,"");
        
        _thread.enter(function _trc_MapURL_ent_compURL(_thread) {
          if (_thread.lastEx) __pc=_thread.catchPC;
          for(var __cnt=100 ; __cnt--;) {
            switch (__pc) {
            case 0:
              url=url.replace(/AAA+/g,(function anonymous_1548(a) {
                var c;
                var buf;
                
                c = a.length;
                
                buf = "";
                
                while (c>0) {
                  buf+="."+String.fromCharCode(65+c);
                  if (c<=26) {
                    c-=26;
                  } else {
                    c=0;
                  }
                  
                }
                return buf;
              }));
              _thread.exit(url);return;
              _thread.exit(_this);return;
            }
          }
        });
      },
      uncompURL :function _trc_MapURL_uncompURL(url) {
        "use strict";
        var _this=this;
        
        url="data:application/zip;base64,"+url;
        url=url.replace(/\.(.)/g,(function anonymous_1856(_,l) {
          var c;
          var buf;
          
          c = l.charCodeAt(0)-65;
          
          buf = "";
          
          while (c>0) {
            buf+="A";
            c--;
            
          }
          return buf;
        }));
        return url;
      },
      fiber$uncompURL :function _trc_MapURL_f_uncompURL(_thread,url) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        url="data:application/zip;base64,"+url;
        
        _thread.enter(function _trc_MapURL_ent_uncompURL(_thread) {
          if (_thread.lastEx) __pc=_thread.catchPC;
          for(var __cnt=100 ; __cnt--;) {
            switch (__pc) {
            case 0:
              url=url.replace(/\.(.)/g,(function anonymous_1856(_,l) {
                var c;
                var buf;
                
                c = l.charCodeAt(0)-65;
                
                buf = "";
                
                while (c>0) {
                  buf+="A";
                  c--;
                  
                }
                return buf;
              }));
              _thread.exit(url);return;
              _thread.exit(_this);return;
            }
          }
        });
      },
      file :function _trc_MapURL_file(path) {
        "use strict";
        var _this=this;
        var f;
        
        f = __superClass.prototype.file.apply( _this, [path]);
        
        return FS.get(f.path());
      },
      fiber$file :function _trc_MapURL_f_file(_thread,path) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var f;
        
        f = __superClass.prototype.file.apply( _this, [path]);
        
        _thread.retVal=FS.get(f.path());return;
        
        
        _thread.retVal=_this;return;
      },
      __dummy: false
    };
  },
  decls: {"methods":{"main":{"nowait":false},"p2c":{"nowait":false},"c2p":{"nowait":false},"fromURL":{"nowait":false},"waitP":{"nowait":false},"toURL":{"nowait":false},"cleanZipFolder":{"nowait":false},"compURL":{"nowait":false},"uncompURL":{"nowait":false},"file":{"nowait":false}},"fields":{"buf":{},"i":{},"byte":{},"map":{},"url":{}}}
});
Tonyu.klass.define({
  fullName: 'user.Test',
  shortName: 'Test',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.Actor,
  includes: [],
  methods: function (__superClass) {
    return {
      main :function _trc_Test_main() {
        "use strict";
        var _this=this;
        
        _this.p1 = Tonyu.globals.$WebPage.param("p1")||"飯島";
        
        _this.p2 = Tonyu.globals.$WebPage.param("p2")||"三木";
        
        Tonyu.globals.$nextURL=Tonyu.globals.$WebPage.param("next");
        Tonyu.globals.$test=true;
        _this.loadPage(Tonyu.classes.user.Main,{names: [_this.p1,_this.p2]});
      },
      fiber$main :function _trc_Test_f_main(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        _this.p1 = Tonyu.globals.$WebPage.param("p1")||"飯島";
        
        _this.p2 = Tonyu.globals.$WebPage.param("p2")||"三木";
        
        Tonyu.globals.$nextURL=Tonyu.globals.$WebPage.param("next");
        Tonyu.globals.$test=true;
        
        _thread.enter(function _trc_Test_ent_main(_thread) {
          if (_thread.lastEx) __pc=_thread.catchPC;
          for(var __cnt=100 ; __cnt--;) {
            switch (__pc) {
            case 0:
              _this.fiber$loadPage(_thread, Tonyu.classes.user.Main, {names: [_this.p1,_this.p2]});
              __pc=1;return;
            case 1:
              
              _thread.exit(_this);return;
            }
          }
        });
      },
      __dummy: false
    };
  },
  decls: {"methods":{"main":{"nowait":false}},"fields":{"p1":{},"p2":{}}}
});

//# sourceMappingURL=concat.js.map